import Node from './node';

export default class Token extends Node {
    constructor(type, value, code) {
        super(type, []);
        this._value = value;
        this._code = code;
        this._codeLength = code;
    }

    get value() {
        return this._value;
    }

    get firstToken() {
        return this;
    }

    get lastToken() {
        return this;
    }

    get code() {
        return this._code;
    }

    get codeLength() {
        return this._codeLength;
    }

    _setChildren(newChildren) {
        if (newChildren.length > 0) {
            throw new Error('Token nodes cannot contain child nodes');
        }

        this._children = newChildren;
    }
}
